/*
 * * * Compile_AHK SETTINGS BEGIN * * *

[AHK2EXE]
Exe_File=%In_Dir%\Sconet2PMB.exe
[ICONS]
Icon_1=%In_Dir%\Sconet2PMB.ico
Icon_2=0
Icon_3=0
Icon_4=0
Icon_5=0
Icon_6=0
Icon_7=0

* * * Compile_AHK SETTINGS END * * *
*/

; ================================================================================
; 								Sconet2PMB
; ================================================================================
;
; 	Par Arnaud Dubois
; 	Ce script convertit les exports de Sconet/STS en fichiers utilisables pour
;	l'import de nouveaux emprunteurs dans PMB.
; 	License : GPL
; 	Ce script permet de crer l'application Sconet2PMB.
; 	Compiler: AutoHotkey (http://www.autohotkey.com/).
; 	$id=Sconet2PMB.ahk $date=2010-03-25
;
; --------------------------------------------------------------------------------
;						Copyright (C) 2010 Arnaud Dubois

;						Website: http://adub115.free.fr

;This software is OSI Certified Open Source Software.
;OSI Certified is a certification mark of the Open Source Initiative.

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA	02110-1301, USA.
; --------------------------------------------------------------------------------


; ================================================================================
; 								Initialisation
; ================================================================================

; On dsactive l'icne de la barre des tches
#NoTrayIcon
#NoEnv
; On force le rpertoire des includes  tre celui du script
#Include xpath.ahk

Gui, Add, GroupBox, x6 y2 w300 h100 , Elves
Gui, Add, Button, x16 y22 w170 h50 gBut_Elev, Cration de la liste lves
Gui, Add, Text, x196 y22 w100 h20 , Trait :
Gui, Add, Text, x196 y52 w100 h20 vCountElev, 
Gui, Add, CheckBox, x16 y72 w280 h30 vb_ImportCode, Importer les INE comme Code Emprunteur
Gui, Add, GroupBox, x6 y102 w300 h80 , Enseignants
Gui, Add, Button, x16 y122 w170 h50 gBut_Prof, Cration de la liste enseignants
Gui, Add, Text, x196 y122 w100 h20 , Trait :
Gui, Add, Text, x196 y152 w100 h20 vCountProf, 
; Generated using SmartGUI Creator 4.0
Gui, Show, x131 y91 h188 w315, Sconet/STS vers PMB
Return

GuiClose:
ExitApp

But_Elev:
{
	Gui, Submit, NoHide
	; initialisation de la variable de sortie
	s_ElevOut := ""
	; Rcupration des correspondances de champs
	IniRead, i_ChampNom, Sconet2PMB.ini, Champs, Nom
	IniRead, i_ChampPrenom, Sconet2PMB.ini, Champs, Prenom
	IniRead, i_ChampNaissance, Sconet2PMB.ini, Champs, Naissance
	IniRead, i_ChampCode, Sconet2PMB.ini, Champs, INE
	IniRead, i_ChampSexe, Sconet2PMB.ini, Champs, Sexe
	IniRead, i_ChampClasse, Sconet2PMB.ini, Champs, Classe
	IniRead, i_ChampMail, Sconet2PMB.ini, Champs, Mail
	IniRead, i_ChampAdr1, Sconet2PMB.ini, Champs, Adresse1
	IniRead, i_ChampAdr2, Sconet2PMB.ini, Champs, Adresse2
	IniRead, i_ChampCommune, Sconet2PMB.ini, Champs, Commune
	IniRead, i_ChampCP, Sconet2PMB.ini, Champs, CodePostal
	IniRead, i_ChampTel, Sconet2PMB.ini, Champs, Telephone
	; Slection du fichier  traiter
	FileSelectFile, f_ElevFile, , , Slectionnez l'export CSV de Sconet :, Fichiers CSV (*.csv)
	If f_ElevFile
		{
		FileRead, s_ElevFile, %f_ElevFile%
		Loop, parse, s_ElevFile, `n, `r
			{
			; par dfaut l'export de Sconet inclut des enttes de colonnes, on saute donc la premire ligne. On saute galement les lignes vides.
			If ((A_Index = 1) || (A_LoopField = ""))
				Continue
			StringSplit, Tampon, A_LoopField, `;
			; Traitement des donnes
			i_AnNaissance := SubStr(Tampon%i_ChampNaissance%, InStr(Tampon%i_ChampNaissance%, "/", "", 0)+1, 4)
			s_Classe := SubStr(Tampon%i_ChampClasse%, 3, StrLen(Tampon%i_ChampClasse%) -3)
			i_Sexe := (Tampon%i_ChampSexe% = "M" ) ? 1 : ((Tampon%i_ChampSexe% = "F" ) ? 2 : 0)
			If b_ImportCode
				s_Code := Tampon%i_ChampCode%
			; Construction de la variable de sortie (mode append)
			s_ElevOut .= s_Code . ";" . Tampon%i_ChampNom% . ";" . Tampon%i_ChampPrenom% . ";" . Tampon%i_ChampAdr1% . ";"
			s_ElevOut .= Tampon%i_ChampAdr2% . ";" . Tampon%i_ChampCP% . ";" . Tampon%i_ChampCommune% . ";" . Tampon%i_ChampTel% . ";"
			s_ElevOut .= i_AnNaissance . ";" . s_Classe . ";" . i_Sexe . ";" . Tampon%i_ChampMail% . ";;`n"
			GuiControl, , CountElev, %A_Index%
			}
		; on trie par ordre alphabtique
		Sort, s_ElevOut
		; R-criture du fichier de sortie
		StringTrimRight, s_ElevOut, s_ElevOut, 1
		FileDelete, ListeElevesPMB.txt
		FileAppend, %s_ElevOut%, ListeElevesPMB.txt
		MsgBox, Traitement termin
		}
Return
}

But_Prof:
{
	s_ProfOut := ""
	s_PPOut := ""
	IniRead, s_GrpProfs, Sconet2PMB.ini, Main, NomGroupeProfesseurs
	FileSelectFile, f_ProfFile, , , Slectionnez l'export XML de STS :, Fichiers XML (*.XML)
	If f_ProfFile
		{
		; Cration d'une version courte du fichier XML
		FileRead, s_ProfFile, %f_ProfFile%
		s_ProfFile := RegExReplace(s_ProfFile, "<PARAMETRES>.*</PARAMETRES>")
		s_ProfFile := RegExReplace(s_ProfFile, "<NOMENCLATURES>.*</NOMENCLATURES>")
		s_ProfFile := RegExReplace(s_ProfFile, "<STRUCTURE>.*</STRUCTURE>")
		FileDelete, XMLTemp.xml
		FileAppend, %s_ProfFile%, XMLTemp.xml
		xml := xpath_load(X_file, "XMLTemp.xml")
		NbCount := xpath(X_file, "/STS_EDT/DONNEES/INDIVIDUS/INDIVIDU/count()")
		Loop, %NbCount%
			{
			s_Nom := xpath(X_file, "/STS_EDT/DONNEES/INDIVIDUS/INDIVIDU[" . A_Index . "]/NOM_USAGE/text()")
			s_Prenom := xpath(X_file, "/STS_EDT/DONNEES/INDIVIDUS/INDIVIDU[" . A_Index . "]/PRENOM/text()")
			s_Naissance := xpath(X_file, "/STS_EDT/DONNEES/INDIVIDUS/INDIVIDU[" . A_Index . "]/DATE_NAISSANCE/text()")
			i_Sexe := xpath(X_file, "/STS_EDT/DONNEES/INDIVIDUS/INDIVIDU[" . A_Index . "]/SEXE/text()")
			s_Classe := xpath(X_file, "/STS_EDT/DONNEES/INDIVIDUS/INDIVIDU[" . A_Index . "]/PROFS_PRINC/PROF_PRINC/CODE_STRUCTURE/text()")
			StringLower, s_Prenom, s_Prenom, T
			StringLeft, s_Naissance, s_Naissance, 4
			s_ProfOut .= ";" . s_Nom . ";" . s_Prenom . ";;;;;;" . s_Naissance . ";" . s_GrpProfs . ";" . Sexe . ";;;`n"
			If s_Classe
				s_PPOut .= s_Classe . ";" . s_Nom . ";" . s_Prenom . "`n"
			GuiControl, , CountProf, %A_Index%
			}
		Sort, s_ProfOut
		StringTrimRight, s_ProfOut, s_ProfOut, 1
		StringTrimRight, s_PPOut, s_PPOut, 1
		FileDelete, XMLTemp.xml
		FileDelete, ListePPPMB.txt
		FileDelete, ListeProfsPMB.txt
		FileAppend, %s_ProfOut%, ListeProfsPMB.txt
		FileAppend, %s_PPOut%, ListePPPMB.txt
		MsgBox, Traitement termin
		}

Return
}


